function primal = PD_wrapper( lcosts, pairs, wcosts, dist, max_iters )

	floating_precision = 'double';
    fp = fopen( '_input.bin', 'wb' );
    if fp == -1
        error( 'cannot write file _input.bin' );
    end
    
	numlabels = size(lcosts,2);
	numpoints = size(lcosts,1);
	numpairs  = size(pairs ,1);
	
	fwrite( fp, numpoints, 'int32' );
	fwrite( fp, numpairs , 'int32' );
	fwrite( fp, numlabels, 'int32' );
	fwrite( fp, max_iters, 'int32' );
	fwrite( fp, lcosts   ,  floating_precision ); clear lcosts;
	fwrite( fp, pairs'   , 'int32' ); clear pairs;
	fwrite( fp, dist     ,  floating_precision ); 
	fwrite( fp, wcosts   ,  floating_precision ); clear wcosts;
	fclose(fp);
    disp(numlabels);
	eval('!"PD.exe" _input.bin _output.bin'); 

	fid = fopen( '_output.bin', 'rb' );
	if fid == -1
		error( 'Cannot open file _output.bin' );
	end

	primal = fread( fid, 'uint8' );

	fclose(fid);

	delete( '_input.bin' );
	delete( '_output.bin' );
end

