function T = dstmtx(n)
%   Discrete sine transform matrix.
%   n is an integer scalar of class double.
%   T is returned as a n x n matrix of class double.
%   
narginchk(1,1);
validateattributes(n,{'double'},{'integer' 'scalar'});
a = 1:n;
T = sqrt(2 / (n+1)) * sin(pi * (a)' *a/ (n+1));

